TCPX DRIVER Statement

#### Search Results

Search

# TCPX DRIVER Statement

The TCPX DRIVER statement and its parameters are used to activate and define the characteristics of the local IBM mainframe node. The access method name TCPX instructs Entire Net-Work to load the line driver module NETTCPX.

In most cases, only one DRIVER statement needs to be coded in your Entire Net-Work startup parameters. However, multiple DRIVER statements can be defined to allow Entire Net-Work to listen on multiple ports.

- DRIVER Statement Format

- Modifying the DRIVER Statement Parameters

- DRIVER Statement Parameters

## DRIVER Statement Format

The TCPX DRIVER statement has the following format:

For more information about syntax conventions and rules used in this section, read Conventions.

## Modifying the DRIVER Statement Parameters

The DRIVER statement parameters are read from a sequential file during system startup, and can be modified after startup using the ALTER operator command. Some parameters can be modified when the line driver is open or closed. Others can be modified only when the line driver is closed. Read about the ALTER and CLOSE commands in TCPX Operator Commands. The open/closed requirement for each parameter is included in the parameter descriptions.

## DRIVER Statement Parameters

This section describes all of the parameters that can be used for the TCPX DRIVER statement.

- ACCEPTUI Parameter

- ADI Parameter

- ADIHOST Parameter

- ADIPART Parameter

- ADIPORT Parameter

- ALLOWIP6 Parameter

- API Parameter

- CONNQUE Parameter

- DRVCHAR Parameter

- DRVNAME Parameter

- KEEPALIV Parameter

- MULTSESS Parameter

- NODELAY Parameter

- NUMUSERS Parameter

- OPTIONS1 Parameter

- OPTIONS2 Parameter

- OUTBUFSZ Parameter

- RCVBUFSZ Parameter

- PSTATS Parameter

- RESTART Parameter

- RSTATS Parameter

- SERVERID Parameter

- STATINT Parameter

- SUBSYS Parameter

- SUPMSGS Parameter

- TRACE Parameter

- TRACELEV Parameter

- TRACESIZ Parameter

- USERID Parameter

- WCPPART Parameter

For more information about syntax conventions and rules used in this section, read Conventions.

### ACCEPTUI Parameter

This optional parameter determines whether the line driver will accept connections from systems that have not been previously defined with LINK statements. The ACCEPTUI parameter can be modified when the line driver is open or closed.

Valid values are "Y" (Yes) or "N" (No).

- If "Y" is specified, Entire Net-Work will accept connection requests from an undefined system and the required control blocks are built dynamically. Normal "handshaking" procedures with the new connections are performed. This is the default.

- If "N" is specified, Entire Net-Work will reject incoming requests from unknown source nodes.

### ADI Parameter

Valid values are "Y" (Yes) or "N" (No).

This parameter specifies if Adabas Directory Server (ADI) support is enabled or disabled. Default is "N" for Net-work nodes, and "Y" for ADATCP.

- If "Y" is specified, Adabas Directory Server (ADI) support is enabled. This is the default for ADATCP.

- If "N" is specified, Adabas Directory Server (ADI) support is disabled. This is the default for Net-work nodes.

### ADIHOST Parameter

No default.

Valid values are 1-255 characters.

This parameter specifies the hostname of the Adabas Directory Server (ADI). The hostname is used to attempt to acquire the TCP/IP address of the system where the ADI resides. If used, ADIHOST and ADIPORT must both be specified.

### ADIPART Parameter

No default.

Valid values are 1-32 characters.

This optional parameter specifies the partition name to be used with the Adabas Directory Server (ADI). If specified, the partition name will be included in all target entries added to the ADI by this session. Partitions are used to restrict database access; when an application queries the ADI for a target and specifies a partition, only entries with the same partition name are returned. Likewise, if the query does not specify a partition, only entries that do not have a partition are returned.

### ADIPORT Parameter

No default.

Valid values are 1-65535.

This parameter specifies the port number used to communicate with the Adabas Directory Server (ADI). If used, ADIHOST and ADIPORT must both be specified.

### ALLOWIP6 Parameter

This optional parameter determines whether the line driver will accept connections using IPv6 communication. When the driver is opened, initialization for IPv6 communication is attempted. If the stack is not IPv6-enabled, IPv4 communication is used.

Valid values are "Y" (Yes) or "N" (No).

- If "Y" is specified, Entire Net-Work will attempt IPv6 communications when the driver is opened. ALLOWIP6=Y is only a valid specification if the API parameter has been set to one of the following values: BS2, HPS, OES, or EZA.

  Note:
  If ALLOWIP6=Y is set in a BS2000 environment, it is listening on the IPv6 address. Connection using an IPv4 address cannot be made.

- If "N" is specified, Entire Net-Work will not attempt IPv6 communications when the driver is opened.

### API Parameter

This required parameter specifies the name of the TCP/IP application program interface being used. The API parameter can be modified only when the line driver is closed. Supported values are shown in the table below. There is no default.

Value | Description | Valid for Platforms
--- | --- | ---
BS2 | Loads the BS2000/OSD interface NWTCPBS2 | BS2000
CNS | Loads the z/VSE interface NWTCPCNS | z/VSE
EZA | Loads the z/VSE interface NWTCPEZA. This option can be used only with the TCP/IP stack from Barnard Software, Inc. | z/VSE
HPS | Loads the IBM interface NWTCPHPS (High Performance Native Sockets) | z/OS and OS/390
OES | Loads the IBM OpenEdition sockets interface NWTCPOES | z/OS and OS/390

### CONNQUE Parameter

This optional parameter specifies the number of connect queue entries. The value specified must accommodate the maximum number of simultaneous connection requests from remote nodes.

After the connection is accepted or rejected, connect queue entries are reused. If the value of this parameter is not high enough, the API routine is not able to process the incoming connection and the partner eventually will time out. Depending on the API being used, a message may be displayed indicating that an error has occurred. Values can range from 1 to 64; a value greater than 64 is reset to 64. The default value is 10. The CONNQUE parameter can be modified only when the line driver is closed.

### DRVCHAR Parameter

This optional parameter specifies the special character used to designate that an operator command should be directed to this line driver rather than to a specific link. The DRVCHAR parameter can be modified only when the line driver is closed.

The default for this parameter is "#".

### DRVNAME Parameter

This optional parameter specifies the 4-byte driver name. The DRVNAME parameter can be modified only when the line driver is closed.

The default for this parameter is "TCPX".

The DRVNAME parameter enables sites to make multiple TCP/IP API routines available at the same time. For example, the IBM APIs can be made available within the same Entire Net-Work address space. This parameter also allows two or more drivers to be defined so that Entire Net-Work can listen on multiple ports simultaneously.

### KEEPALIV Parameter

This optional parameter allows you to maintain connections when there is no other traffic with the remote links. Valid values are "Y" or "N."

- When this value is set to "Y", it causes internal TCP messages to be sent periodically to all remote links, thus maintaining the connections when there is no other traffic with the remote links. The amount of time between messages is determined by the TCP/IP stack.

- When this value is set to "N", internal TCP messages are no longer sent periodically and the connections are not maintained.

The default for this parameter is "N".

KEEPALIV can also be set for individual remote links. For more information, read about the KEEPALIV parameter associated with the TCPX LINK statement.

### MULTSESS Parameter

This optional parameter determines whether a connect request from a host that has an active connection is treated as a new link. This parameter can be modified when the line driver is open or closed.

A value of "Y" indicates that the connect request is treated as a new link; a value of "N" indicates that the connect request is rejected.

The default for this parameter is "Y".

### NODELAY Parameter

This optional parameter allows you to indicate whether the IBM socket option TCP_NODELAY is enabled or disabled for a link. TCP_NODELAY indicates whether data sent over the socket is subject to the Nagle algorithm (RFC 896). For more information, refer to your IBM documentation.

Valid values for this parameter are "Y" (the TCP_NODELAY option is enabled) or "N" (the TCP_NODELAY option is disabled). The default is "Y". When the NODELAY parameter on the DRIVER statement is specified, you do not need to specify the NODELAY parameter on the LINK statement. The value from the DRIVER statement is used. If the NODELAY parameter is not specified on either the DRIVER or LINK statements, a value of "Y" is assumed.

Note:
The setting of this parameter is only effective if the API parameter is also set to "OES" or "HPS."

### NUMUSERS Parameter

This parameter specifies the estimated maximum number of concurrently active clients. For performance reasons, a table of individual client entries is preallocated based on this number. During the Entire Net-Work session, if the number of active clients is exceeded, the table is automatically expanded by 50% of the current value. The size of each entry in the table is 256 bytes. The minimum value is 10, maximum is 32767. The default is 100.

Note:
This parameter can only be altered when the driver is closed.

### OPTIONS1 Parameter

Note
This parameter is obsolete. It is available for compatibility reasons only.

This optional parameter allows up to ten numeric API-specific options to be set. The values can be modified when the line driver is open or closed. There are no default values.

### OPTIONS2 Parameter

Note
This parameter is obsolete. It is available for compatibility reasons only.

This optional parameter allows up to five alphanumeric API-specific options to be set. The values can be modified when the line driver is open or closed. There are no default values.

### OUTBUFSZ Parameter

OUTBUFSZ specifies the size of the output buffer.

An output buffer is allocated for each link that is a direct client connection. It is used for the output buffers for an Adabas call, such as the Record Buffer. This pre-allocated buffer avoids the overhead of allocating and freeing a buffer for each Adabas call. If the output buffer is too small, a separate buffer is allocated for that call only. The link statistics show how many times, if any, the output buffer was too small.

Note that the output buffer is only allocated for direct clients. Links that are connected to another Net-Work kernel do not allocate this output buffer.

The default size is 32K. OUTBUFSZ can be specified in bytes, kilobytes, or megabytes. Example: OUTBUFSZ=2M

### RCVBUFSZ Parameter

RCVBUFSZ specifies the size of the TCP/IP receive buffer. A receive buffer is allocated for each link. If the message is too big to fit in the receive buffer, a separate buffer is allocated for that call only. The link statistics show how many times, if any, the receive buffer was too small to receive the entire message.

The default size is 32K. RCVBUFSZ can be specified in bytes, kilobytes, or megabytes. Example: RCVBUFSZ=64K

### PSTATS Parameter

This optional parameter determines whether or not statistics are printed.

A value of "Y" indicates that statistics should be printed to DDPRINT when the statistics interval expires; a value of "N" indicates that the statistics should not be printed.

This parameter does not affect the STATS command and can be modified when the driver is open or closed.

The default for this parameter is "N".

### RESTART Parameter

This optional parameter specifies the retry interval in seconds (interval) and the number of retries (retries) that Entire Net-Work will attempt to reopen the access method with the API after a shutdown due to a failure. The RESTART parameter can be modified when the line driver is open or closed.

If RESTART is not specified, or interval is specified as zero, no retry is attempted. By specifying (retries) as zero, an infinite number of retries can be requested.

The RESTART parameter is particularly useful with the Simple Connection Line Driver when Entire Net-Work is started at IPL and communication with the API is unsuccessful because TCP/IP is not yet fully initialized. Using this parameter, you can instruct Entire Net-Work to reopen the TCP/IP session, thereby giving TCP/IP sufficient time to become active.

The TIMER parameter on the NODE statement affects the RESTART parameter (see the section Entire Net-Work NODE Statement.) The retry interval should not be less than the TIMER parameter, and should be a multiple of this value. If a retry interval other than zero is specified that is less than the value of the TIMER parameter, the TIMER value is used instead.

### RSTATS Parameter

This optional parameter determines whether or not statistics are reset. A value of "Y" indicates that statistics should be reset when the statistics interval expires; a value of "N" indicates that the statistics should not be reset. The default is "N".

The RSTATS parameter can be modified when the line driver is open or closed.

The statistics interval value is set by link parameter STATINT. If LINK parameter STATINT is not define, the interval is set by the DRIVER parameter STATINT.

### SERVERID Parameter

This optional parameter specifies a well known port number used by Entire Net-Work while awaiting connection requests from participating Entire Net-Work partners. Values may range from 1 to 65535. The SERVERID parameter can be modified only when the line driver is closed.

When specified in a DRIVER statement, the SERVERID parameter specifies the port number of the Entire Net-Work being initialized. If SERVERID is not specified for a link, the SERVERID specified for the driver is used as the default port for the link.

The default for this parameter is 1996.

### STATINT Parameter

This optional parameter specifies the amount of time, in seconds, before statistics are automatically printed or reset. The default is 3600. The STATINT parameter can be modified when the line driver is open or closed.

Acceptable values range from 1 to 2147483647. Any value outside this range is in error.

### SUBSYS Parameter

Note
This parameter is obsolete. It is available for compatibility reasons only.

This parameter specifies the name of the subsystem to be accessed by the API routines that use subsystem control blocks in interaddress space communications. The default value is VMCF. The SUBSYS parameter can be modified only when the line driver is closed.

In a z/OS environment, the IBM API routines communicate to the system address space by locating the subsystem control table and retrieving the information required to perform cross-memory communication. If the subsystem is specified incorrectly, the driver is not able to perform its open processing and no connections are possible.

### SUPMSGS Parameter

This optional parameter suppresses printout of the following messages in the TCPX DRIVER: NETP818I and NETP819I. This allows you to avoid cluttering your logs with these connection and disconnection messages.

Valid values are "Y" (Yes) or "N" (No):

- If "Y" is specified, the NETP0818I Connect, and NETP0819I Disconnect messages are suppressed (no longer output to the log).

- If "N" is specified, the NETP0818I and NETP0819I messages are output to the log.

### TRACE Parameter

This parameter indicates whether tracing for this line driver should be active (Y) or not (N). When tracing is activated, trace information is placed in the trace table. The default is N (no). The TRACE parameter can be modified when the line driver is open or closed.

This is equivalent to specifying `TRACE=linedriver-code` or `TRON=linedriver-code` in the NODE statement (for example, TRACE=CTCA).

### TRACELEV Parameter

Note
This parameter is obsolete. It is available for compatibility reasons only.

This optional parameter specifies the levels of tracing that the line driver will perform. It is a series of flags that determine which events are traced. The TRACELEV specification must be enclosed in parentheses. For example:

    TRACELEV=(N,N,N,N,N,N,N,N,N,N)

Trace levels are positional within the parameter syntax and are set using Y (Yes) or N (No). It is recommended that all settings within the TRACELEV parameter be N. If your system experiences problems, contact your Software AG technical support representative for the settings that produce the appropriate trace information. The TRACELEV parameter can be modified when the line driver is open or closed.

Note:
The tracing information provided is sent to the DDPRINT data set. In addition to setting the TRACELEV flags, the trace must also be turned on using either the DRIVER statement parameter `TRACE=Y` or the operator command `TRACE=linedriver-name`. Tracing dramatically affects the overall performance and throughput of Entire Net-Work.

### TRACESIZ Parameter

This optional parameter specifies the size, in bytes, of the driver-specific trace table.

This parameter is also used as the default size of the link specific trace table when the LINK statement does not include a TRACESIZ specification.

Valid values can range from 4096 to 4194304. A value less than 4096 is reset to 4096; a value greater than 4194304 is reset to 4194304.

The TRACESIZ parameter can be modified only when the line driver is closed.

The default for this parameter is "4096".

### USERID Parameter

This parameter's value can be modified only when the line driver is closed.

- For IBM APIs (i.e., the NWTCPIBM interface, the NWTCPHPS interface, and the NWTCPOES interface), the USERID parameter specifies the name of the started task, job, or virtual machine in which the IBM TCP/IP protocol stack is running. The value is 1-8 characters. The default value is TCPIP.

- For the CNS API (i.e., the NWTCPCNS interface), the USERID parameter is used to direct traffic to a particular TCP/IP stack. The value is a two-digit number that must match the ID= value in the PARM field of the TCP/IP stack. The default value is 00, which is also the default for the TCP/IP stack. The value of USERID is not validated; if its value does not match the ID= value of an active TCP/IP stack, the TCP/IP driver will fail to open and it will return messages similar to the following:

      NETP571W TCP API ERROR ON OPEN - RC = 0008
      NET0101I  TCPI DRIVER OPEN FAILED - RC = 0004

  To use multiple TCP/IP stacks, one DRIVER statement must be provided for each stack, and each link must specify the driver associated with the stack it will use. When defining multiple drivers, copy the module NETTCPI.phase and change the last four characters of the name to match the DRIVER name. For example, to define the following, NETTCPI would be copied (not renamed) to NETTCP2:

      *Links using Driver TCPI use TCP/IP stack with ID=00
      DRIVER TCPI  API=CNS
      LINK PC01 TCPI,INETADDR=(x,x,x,x)

      *Links using Driver TCP2 use TCP/IP stack with ID=02
      DRIVER TCP2 API=CNS,USERID=02,DRVNAME=TCP2
      LINK PC02 TCP2,INETADDR=(x,x,x,x)

### WCPPART Parameter

WCPPART is an alias of ADIPART and works in the same way as ADIPART.

### On this page

- DRIVER Statement Format
- Modifying the DRIVER Statement Parameters
- DRIVER Statement Parameters